; Standard CBM 264 series I/O ports 
; ---------------------------------

cpu_dir		= $0
cpu_port		= $1

acia		= $fd00
pio_parport 	= $fd10
pio_keyboard 	= $fd30
rom_bank_latch 	= $fdd0
	
ted		= $ff00

; Expansions
; ----------

tcbm_8		= $fef0
tcbm_9		= $fec0
	
; Custom expansions
; -----------------

; Csory RAM expansion control 
; Bit 7-6: main memory window select (00: $0000, 01: $4000, 10: $8000, 11: $c000)
;     5-4: unused (avaliable for 1M RAM expansion) 
;     3-0: 16k memory bank select to display in main memory window (16x16k = 256k)
; See also Hannes control register bit 6 
; Default value: $00
ramexpctrl_csory	= $fd15
; Hannes RAM expansion control
; Bit   7: expansion memory switch bound: 0:$1000, 1:$4000
;       6: expansion disable for TED: 0: access only default bank (11), 
;                                     1: access like CPU
;          affects Csory expansion too 
;     5-4: activate Csory expansion with 10, other values switch it off
;          address bits 21-20 for 4M Hannes RAM expansion
;     3-2: unused
;          address bits 19-18 for 1M Hannes RAM expansion 
;     1-0: 64k memory bank select 
; Caution! Bits 1&0 are inverted!
; Default value: $ff
ramexpctrl_hannes	= $fd16

sid_solder	= $fd40
nae_control	= $fd80
sid_csory		= $fe80
