	.include "kernal-table.inc"
	.include "plus4_io_map.inc"
	.include "ted.inc"

dir_top_x	=	0
dir_top_y	=	2
dir_bot_y	=	25

ptr1	=	8
ptr2	=	10

loadptr	=	$9d
currdrive	=	$ae
currcolor	=	$053b
keyrepeat	=	$0541
shift	=	$0543

screenbase=	$0c00

io_sidbase	= $0bfd
io_soundtype	= $0bff

c64sid	=	$d400
c64cia1	=	$dc00

;.include	"../include/basic_header.inc"
;jmp $4000
	*=$4000

relocatedplayer	= $1000
playerarea	= *

	; Use last used drive or #8
	lda	#8
	cmp	currdrive
	bcc	+
-	sta	currdrive
+	ldx	#16
	cpx	currdrive
	bcc	-
	lda	#$1e
	sta	ted_background
	sta	ted_border
	lda	#$75
	sta	currcolor
	ldx	#0
-	sta	screenbase-$400,x
	sta	screenbase-$300,x
	sta	screenbase-$200,x
	sta	screenbase-$118,x
	inx
	bne	-
	lda	#>screenbase
	ldx	#>winbuflo
	ldy	#>winbufhi
	jsr	winit
	lda	#$60	; RTS when all windows closed
	sta	allclosd
	lda	#0
	jsr	setmsg
	jsr	io_det_sound
	bit	io_soundtype
	bpl	+
	lda	#$d3
	sta	nae_control+13	; Init NAE for C64 clock+$d400 write enabled
	
+	lda	ted_ctrl2
	lsr
	lsr
	lsr
	lsr
	lsr
	lsr
	sta	currstd
	
reread	jsr	initscreen
	lda	#<wd_reading
	ldx	#>wd_reading
	jsr	wopen
	jsr	readdir
	jsr	wclose

	lda	st
	and	#%00111111
	beq	+	; was normal eof
	lda	#<wd_status
	ldx	#>wd_status
	jsr	wopen
	jsr	readstatus
	jsr	wclose
	
+	jsr	updateheader
	jsr	displaydir
	jsr	displayselection
	
menuloop	jsr	getchar
	ldx	#1
	stx	keyrepeat

	cmp	#$11
	bne	not_down
	lda	#1
	bit	shift
	beq	+
	jsr	b_s_down
	jmp	menuloop
+	jsr	b_down
	jmp	menuloop

not_down	cmp	#$91
	bne	not_up
	lda	#1
	bit	shift
	beq	+
	jsr	b_s_up
	jmp	menuloop
+	jsr	b_up
	jmp	menuloop

not_up	cmp	#"r"
	beq	reread

	cmp	#"d"
	bne	not_d
	lda	currdrive
	pha
	lda	#<wd_driveselector
	ldx	#>wd_driveselector
	jsr	wopen
	jsr	changedrive
	jsr	wclose
	pla
	cmp	currdrive
	bne	reread
	beq	menuloop

not_d	cmp	#13		; return
	bne	not_return
	lda	numofentries
	ora	numofentries+1
	beq	menuloop
	jsr	getselfile
	lda	filename+17
	cmp	#"d"
	bne	+
	lda	filename+18
	cmp	#"9"+1
	bcc	doright		; dxx disk image
	cmp	#"i"
	bne	+
	lda	filename+19
	cmp	#"r"
	beq	doright
+	lda	#<wd_loading
	ldx	#>wd_loading
	jsr	wopen
	jsr	readsid
	jsr	wclose
	lda	magicId
	cmp	#"p"
	bne	+
	lda	#<wd_sidinfo
	ldx	#>wd_sidinfo
	jsr	wopen
	lda	relocated
	bne	relocplay
	jsr	playsid
-	jsr	w_close
	jmp	reread
relocplay	jsr	relocate
	jsr	sizplay_relocated
	jmp	-
+	cmp	#"r"
	beq	rsid
	lda	#<wd_notapsid
	ldx	#>wd_notapsid
	bne	+
rsid	lda	#<wd_rsid
	ldx	#>wd_rsid
+	jsr	wopen
	jsr	wchoose
	jmp	menuloop

not_return
	cmp	#$1d
	bne	not_right
	lda	numofentries
	ora	numofentries+1
	bne	doright
	jmp	menuloop
doright	jsr	b_right
	jmp	reread

not_right	cmp	#$9d
	bne	not_left
	jsr	b_left
	jmp	reread
not_left
	jmp	menuloop

b_down	lda	#1
	jsr	incselected
	lda	firstdisplayed	; calculate last row on screen
	clc
	adc	#dir_bot_y-dir_top_y
	sta	temp1
	lda	firstdisplayed+1
	adc	#0
	sta	temp1+1
	lda	temp1
	cmp	selectedentry	; if it's not displayed
	bne	+
	lda	temp1+1
	cmp	selectedentry+1
	bne	+
	inc	firstdisplayed	; increase firstdisplayed
	bne	+
	inc	firstdisplayed+1
+	jsr	displaydir
	jmp	displayselection

b_s_down	lda	#dir_bot_y-dir_top_y
	jsr	incselected
	lda	firstdisplayed	; increase firstdisplayed by number of rows
	clc
	adc	#dir_bot_y-dir_top_y
	sta	firstdisplayed
	lda	firstdisplayed+1
	adc	#0
	sta	firstdisplayed+1
	lda	numofentries
	sec
	sbc	#dir_bot_y-dir_top_y
	sta	temp1
	lda	numofentries+1
	sbc	#0
	sta	temp1+1
	bpl	+
	lda	#0
	sta	temp1
	sta	temp1+1
+	lda	firstdisplayed
	cmp	temp1
	lda	firstdisplayed+1
	sbc	temp1+1
	bmi	+
	lda	temp1
	ldx	temp1+1
	sta	firstdisplayed
	stx	firstdisplayed+1
+	jsr	displaydir
	jmp	displayselection

b_up	lda	#1
	jsr	decselected
	lda	firstdisplayed	; if firstdisplayed = selectedentry+1
	clc
	sbc	selectedentry
	lda	firstdisplayed+1
	sbc	selectedentry+1
	bne	+
	lda	selectedentry	; firstdisplayed = selectedentry
	ldx	selectedentry+1
	sta	firstdisplayed
	stx	firstdisplayed+1
+	jsr	displaydir
	jmp	displayselection

b_s_up	lda	#dir_bot_y-dir_top_y
	jsr	decselected
	lda	firstdisplayed	; decrease firstdisplayed by number of rows
	sec
	sbc	#dir_bot_y-dir_top_y
	sta	firstdisplayed
	lda	firstdisplayed+1
	sbc	#0
	sta	firstdisplayed+1
	bpl	+
	lda	#0		; if result is negative set to zero
	sta	firstdisplayed
	sta	firstdisplayed+1
+	jsr	displaydir
	jmp	displayselection

; Increase currently selected entry number by the number in A
incselected
	clc
	adc	selectedentry
	sta	selectedentry
	bcc	+
	inc	selectedentry+1
+	lda	numofentries
	clc
	sbc	selectedentry
	lda	numofentries+1
	sbc	selectedentry+1
	bcs	+
	lda	numofentries
	sec
	sbc	#1
	sta	selectedentry
	lda	numofentries+1
	sbc	#0
	sta	selectedentry+1
+	rts

; Decrease currently selected entry number by the number in A
decselected
	sec
	eor	#$ff		; add negate of number do to subtraction
	adc	selectedentry
	sta	selectedentry
	bcs	+
	dec	selectedentry+1
+	bit	selectedentry+1
	bpl	+
	lda	#0
	sta	selectedentry
	sta	selectedentry+1
+	rts

b_left	lda	#$5f	; left arrow
	sta	filename
	lda	#0
	sta	filename+1
	lda	#3
-	ldx	#<cdcommand
	ldy	#>cdcommand
	jsr	setnam
	lda	#1
	ldx	currdrive
	ldy	#15
	jsr	setlfs
	jsr	open
	jsr	clrchans
	lda	#1
	jsr	close
	rts
; Display status after change dir
;	lda	#<wd_status
;	ldx	#>wd_status
;	jsr	wopen
;	jsr	readstatus
;	jmp	wclose
b_right	jsr	getselfile
	ldx	#$ff
-	inx
	lda	cdcommand,x
	bne	-
	txa
	bne	--

getselfile
	lda	selectedentry
	ldx	selectedentry+1
	sta	loadptr
	stx	loadptr+1
	asl	loadptr
	rol	loadptr+1
	asl	loadptr
	rol	loadptr+1
	lda	selectedentry
	adc	loadptr
	sta	loadptr
	lda	selectedentry+1
	adc	loadptr+1
	sta	loadptr+1
	asl	loadptr
	rol	loadptr+1
	asl	loadptr
	rol	loadptr+1
	lda	#<direntries
	adc	loadptr
	sta	loadptr
	lda	#>direntries
	adc	loadptr+1
	sta	loadptr+1
	ldy	#19
	php
	sei
	sta	ted_ramen
-	lda	(loadptr),y
	sta	filename,y
	dey
	bpl	-
	sta	ted_romen
	plp
	rts

changedrive
	lda	currdrive
	pha
	lda	currcolor
	pha
	lda	wd_driveselector+4
	sta	currcolor
	lda	#8
	sta	currdrive
-	ldx	currdrive
	ldy	#4
	clc
	jsr	plot
	jsr	prtstatus
	bit	st
	bvs	+
	jsr	primm
	.byte	$12
	.null	"--device not present--"
+	inc	currdrive
	lda	currdrive
	cmp	#16
	bne	-
	lda	#$92
	jsr	chrout
	pla
	sta	currcolor
	pla
	sta	currdrive
	pha
-	jsr	displaydrvselector
-	jsr	getchar
	beq	-
	cmp	#13
	bne	+
	pla
	rts
+	cmp	#27
	bne	+
	pla
	sta	currdrive
	rts
+	cmp	#$11
	bne	++
	jsr	displaydrvselector
-	ldx	currdrive
	inx
	cpx	#16
	bne	+
	ldx	#8
+	stx	currdrive
	jsr	checkdrv
	beq	-
	bne	---
+	cmp	#$91
	bne	--
	jsr	displaydrvselector
-	ldx	currdrive
	dex
	cpx	#7
	bne	+
	ldx	#15
+	stx	currdrive
	jsr	checkdrv
	beq	-
	bne	----

displaydrvselector
	lda	currdrive
	asl
	tax
	lda	scrntab,x
	sta	loadptr
	lda	scrntab+1,x
	sta	loadptr+1
	ldy	#4
-	lda	(loadptr),y
	eor	#%10000000
	sta	(loadptr),y
	iny
	cpy	#39
	bne	-
	rts

checkdrv	lda	currdrive
	asl
	tax
	lda	scrntab,x
	sta	loadptr
	lda	scrntab+1,x
	sta	loadptr+1
	ldy	#4
	lda	(loadptr),y
	and	#%01111111
	cmp	#"-"
	rts

initscreen
	lda	#8
	jsr	chrout
	lda	#14
	jsr	chrout
	ldx	#0
-	lda	browserscreen,x
	sta	screenbase,x
	lda	browserscreen+$100,x
	sta	screenbase+$100,x
	lda	browserscreen+$200,x
	sta	screenbase+$200,x
	lda	browserscreen+$2e8,x
	sta	screenbase+$2e8,x
	inx
	bne	-
	ldx	#18
-
; Logo color
	lda	#$69
	sta	screenbase-$0400+21,x
	sta	screenbase-$0400+61,x
	sta	screenbase-$0400+101,x
	sta	screenbase-$0400+141,x
	sta	screenbase-$0400+181,x
	sta	screenbase-$0400+221,x
	sta	screenbase-$0400+261,x
	sta	screenbase-$0400+301,x
	sta	screenbase-$0400+341,x
; Heading lines
	lda	#$48
	sta	screenbase-$0400+461,x
	sta	screenbase-$0400+501,x
	sta	screenbase-$0400+821,x
	sta	screenbase-$0400+861,x
	dex
	bpl	-
; Version number
	lda	#$54
	sta	screenbase-$0400+354
	sta	screenbase-$0400+355
	sta	screenbase-$0400+356
; Hot keys
	lda	#$71
	sta	screenbase-$0400+542
	sta	screenbase-$0400+543
	sta	screenbase-$0400+545
	sta	screenbase-$0400+546
	sta	screenbase-$0400+547
	sta	screenbase-$0400+548

	sta	screenbase-$0400+582
	sta	screenbase-$0400+583
	sta	screenbase-$0400+585
	sta	screenbase-$0400+586
	sta	screenbase-$0400+588
	sta	screenbase-$0400+589
	sta	screenbase-$0400+590
	sta	screenbase-$0400+591

	sta	screenbase-$0400+622
	sta	screenbase-$0400+623
	sta	screenbase-$0400+624
	sta	screenbase-$0400+626
	sta	screenbase-$0400+627
	sta	screenbase-$0400+628
	
	sta	screenbase-$0400+662
	sta	screenbase-$0400+663
	sta	screenbase-$0400+664
	sta	screenbase-$0400+665
	sta	screenbase-$0400+666
	sta	screenbase-$0400+667

	sta	screenbase-$0400+702

	sta	screenbase-$0400+742

	sta	screenbase-$0400+902
	sta	screenbase-$0400+903
	sta	screenbase-$0400+904

	sta	screenbase-$0400+942
	sta	screenbase-$0400+943
	sta	screenbase-$0400+944
	sta	screenbase-$0400+945
	sta	screenbase-$0400+946

	sta	screenbase-$0400+982
	sta	screenbase-$0400+983
	sta	screenbase-$0400+984
	sta	screenbase-$0400+986
	sta	screenbase-$0400+987
	sta	screenbase-$0400+988

; Frames
	lda	#$77
	sta	screenbase-$0400
	sta	screenbase-$0400+3
	ldx	#19
-	sta	screenbase-$0400+40,x
	dex
	bpl	-

	sta	screenbase-$0400+20
	sta	screenbase-$0400+60
	sta	screenbase-$0400+100
	sta	screenbase-$0400+140
	sta	screenbase-$0400+180
	sta	screenbase-$0400+220
	sta	screenbase-$0400+260
	sta	screenbase-$0400+300
	sta	screenbase-$0400+340
	sta	screenbase-$0400+380
	sta	screenbase-$0400+420
	sta	screenbase-$0400+460
	sta	screenbase-$0400+500
	sta	screenbase-$0400+540
	sta	screenbase-$0400+580
	sta	screenbase-$0400+620
	sta	screenbase-$0400+660
	sta	screenbase-$0400+700
	sta	screenbase-$0400+740
	sta	screenbase-$0400+780
	sta	screenbase-$0400+820
	sta	screenbase-$0400+860
	sta	screenbase-$0400+900
	sta	screenbase-$0400+940
	sta	screenbase-$0400+980
	rts
	
updateheader
	lda	currdrive
	cmp	#10
	php
	pha
	lda	#"0"
	adc	#0	; add carry
	sta	screenbase+1
	pla
	plp
	bcc	+
	sbc	#10
+	clc
	adc	#"0"
	sta	screenbase+2

	ldx	#0
-	lda	disklabel,x
	beq	+
	and	#%10111111
	sta	screenbase+4,x
	inx
	bne	-
-
+	rts
	
displaydir
	lda	numofentries
	ora	numofentries+1
	beq	-
	php
	lda	firstdisplayed
	ldx	firstdisplayed+1
	sta	loadptr
	stx	loadptr+1
	asl	loadptr
	rol	loadptr+1
	asl	loadptr
	rol	loadptr+1
	lda	firstdisplayed
	adc	loadptr
	sta	loadptr
	lda	firstdisplayed+1
	adc	loadptr+1
	sta	loadptr+1
	asl	loadptr
	rol	loadptr+1
	asl	loadptr
	rol	loadptr+1
	lda	#<direntries
	adc	loadptr
	sta	loadptr
	lda	#>direntries
	adc	loadptr+1
	sta	loadptr+1
	lda	#0
	sta	temp2		; temp2=currently displayed file entry
	sta	temp2+1
	ldx	#dir_top_y
-	stx	temp1		; temp1=current screen row
	txa
	asl
	tax
	lda	scrntab,x
	adc	#dir_top_x
	sta	ptr1
	lda	scrntab+1,x
	adc	#0
	sta	ptr1+1
	sei
	ldy	#0
	sta	ted_ramen
-	lda	(loadptr),y
	bne	+
	lda	#" "
+	and	#%10111111
	sta	(ptr1),y
	iny
	cpy	#20
	bne	-
	sta	ted_romen
	tya
	clc
	adc	loadptr
	sta	loadptr
	bcc	+
	inc	loadptr+1
+	ldx	temp1
	inx
	inc	temp2
	bne	+
	inc	temp2+1
+	cpx	#dir_bot_y
	beq	+
	lda	numofentries
	cmp	temp2
	bne	--
	lda	numofentries+1
	cmp	temp2+1
	bne	--
+	plp
-
	rts

displayselection
	lda	numofentries
	ora	numofentries+1
	beq	-
	lda	selectedentry
	clc
	adc	#dir_top_y
	sec
	sbc	firstdisplayed
	asl
	tax
	lda	scrntab,x
	sta	loadptr
	lda	scrntab+1,x
	sta	loadptr+1
	ldy	#dir_top_x
-	lda	(loadptr),y
	eor	#%10000000
	sta	(loadptr),y
	iny
	cpy	#dir_top_x+20
	bne	-
	rts

readdir	lda	#<direntries
	ldx	#>direntries
	sta	loadptr
	stx	loadptr+1
	lda	#0
	sta	numofentries
	sta	numofentries+1
	sta	disklabel
	sta	firstdisplayed
	sta	firstdisplayed+1
	sta	selectedentry
	sta	selectedentry+1
	lda	#1
	ldx	currdrive
	ldy	#0
	jsr	setlfs
	lda	#1
	ldx	#<dirname
	ldy	#>dirname
	jsr	setnam
	jsr	open
	lda	st
	bne	+
	ldx	#1
	jsr	chkin
	lda	st
	bne	+
	jsr	readdiskheader
	bcs	+
	lda	#<direntries
	ldx	#>direntries
	sta	loadptr
	stx	loadptr+1
-	jsr	readdirentry
	bcc	-
+	jsr	clrchans
	lda	#1
	jsr	close
	rts

readstatus
        	lda	currcolor
	pha
	lda	wd_status+4
	sta	currcolor
	ldx	#11
	ldy	#6
	clc
	jsr	plot
	
	jsr	prtstatus
	pla
	sta	currcolor
	
-	jsr	getchar
	beq	-
	rts

prtstatus	lda	#$12
	jsr	chrout
	lda	#1
	ldx	currdrive
	ldy	#15
	jsr	setlfs
	lda	#0
	jsr	setnam
	jsr	open
	lda	st
	bne	+
	ldx	#1
	jsr	chkin
	lda	st
	bne	+
-	jsr	chrin
	jsr	chrout
	ldx	st
	beq	-
+	jsr	clrchans	
	lda	#1
	jsr	close
	lda	#$92
	jmp	chrout
	
readdiskheader
	ldx	#0
	txa
	sta	disklabel
	ldx	#6	; Skip 6 bytes: loadaddress, next line address, line number
-	jsr	chrin
	ldy	st
	bne	++
	dex
	bne	-
-	jsr	chrin
	ldy	st
	bne	++
	cmp	#$22
	bne	-
-	jsr	chrin
	ldy	st
	bne	++
	cmp	#$22
	beq	+
	sta	disklabel,x
	inx
	bne	-
+	lda	#0
	sta	disklabel,x
-	jsr	chrin
	ldy	st
	bne	+
	cmp	#0
	bne	-
	clc
	.byte	$24
+	sec
	rts

readdirentry
	.block
	ldx	#0
	stx	temp1
	ldx	#4	; Skip 4 bytes: next line address, line number
-	jsr	chrin
	ldy	st
	bne	enderr
	dex
	bne	-
-	jsr	chrin
	ldy	st
	bne	enderr
	cmp	#$22
	bne	-	; read until first "
-	jsr	chrin
	ldy	st
	bne	enderr
	cmp	#$22
	bne	+
	lda	#0	; store $00 instead of the second "	
+	jsr	storebyte
	cmp	#0
	beq	+
	ldx	temp1
	inx
	stx	temp1
	bne	-
+	jsr	chrin	; skip one byte
-	jsr	chrin
	beq	end
	ldy	st
	bne	enderr
	ldx	temp1
	cpx	#16
	bcs	+
	lda	#" "	; store space instead of any characters before the file type
+	cpx	#19
	bcs	+
	jsr	storebyte
+	inx
	stx	temp1
	bne	-
end	inc	numofentries
	bne	+
	inc	numofentries+1
+	clc
	.byte	$24
enderr	sec
	rts
	.bend
	
storebyte	sta	(loadptr),y
	inc	loadptr
	bne	+
	inc	loadptr+1
+	rts

readsid	lda	#1
	sta	magicId
	ldx	currdrive
	ldy	#0
	sty	temp1
	sty	relocated
	jsr	setlfs
	ldx	#$ff
-	inx
	lda	filename,x
	bne	-
	lda	filetype
	cmp	#"p"
	beq	+
	pha
	lda	#","
	sta	filename,x
	inx
	pla
	sta	filename,x
	inx
+	txa
	ldx	#<filename
	ldy	#>filename
	jsr	setnam
	jsr	open
	lda	st
	beq	+
	jmp	endreaderr
+	ldx	#1
	jsr	chkin
	lda	st
	beq	+
	jmp	endreaderr
+	lda	#sidheaderend-sidheader
	sta	dataoffset+1
-	jsr	chrin
	ldx	temp1
	; process input
	cpx	#sidheaderend-sidheader
	bcs	+
	sta	sidheader,x
+	inx
	stx	temp1
	cpx	dataoffset+1
	bcs	+
	lda	st
	beq	-
	jmp	endreaderr
+	lda	magicId+1
	cmp	#"s"
	bne	endreaderr
	lda	magicId+2
	cmp	#"i"
	bne	endreaderr
	lda	magicId+3
	cmp	#"d"
	bne	endreaderr
	lda	magicId
	cmp	#"r"
	beq	endreaderr2
	cmp	#"p"
	bne	endreaderr
	lda	loadaddress
	ora	loadaddress+1
	beq	+
	lda	loadaddress+1
	ldx	loadaddress
	sta	loadptr
	stx	loadptr+1
	bne	++
+	jsr	chrin
	sta	loadptr
	jsr	chrin
	sta	loadptr+1
+	lda	loadptr+1
	cmp	#$30
	bcc	+
	cmp	#>direntries
	bcs	+
	inc	relocated
	bne	+
endreaderr
	lda	#0
	sta	magicId
endreaderr2
	jmp	enderr
+	rts

relocate	ldy	#0
	lda	#>relocatedplayer
	ldx	#>playerarea
	sty	ptr1
	sta	ptr1+1
	sty	ptr2
-	stx	ptr2+1
-	lda	(ptr2),y
	sta	(ptr1),y
	iny
	bne	-
	inc	ptr1+1
	ldx	ptr2+1
	inx
	cpx	#>winbufhi
	bne	--
	ldx	#0
-	lda	sidheader,x
	sta	sizplay_relocated.sidheader,x
	inx
	cpx	#sidheaderend-sidheader
	bne	-
	rts

relocated
	.byte	0

	.include	"sizplay_player.inc"
	.logical	relocatedplayer+*-playerarea
sizplay_relocated	.block
	jsr	playsid

	ldy	#0
	lda	#>relocatedplayer
	ldx	#>playerarea
	sty	ptr1
	sta	ptr1+1
	sty	ptr2
-	stx	ptr2+1
-	lda	(ptr1),y
	sta	(ptr2),y
	iny
	bne	-
	inc	ptr1+1
	ldx	ptr2+1
	inx
	cpx	#>winbufhi
	bne	--
	rts

	.include	"sizplay_player.inc"

	.bend
	.here
	
io_prtstatus	=	0
	.include	"detect_sound.inc"
	.include	"windows3.4.inc"

scrntab	.word	screenbase, screenbase+40,screenbase+80
	.word	screenbase+120, screenbase+160,screenbase+200
	.word	screenbase+240, screenbase+280,screenbase+320
	.word	screenbase+360, screenbase+400,screenbase+440
	.word	screenbase+480, screenbase+520,screenbase+560
	.word	screenbase+600, screenbase+640,screenbase+680
	.word	screenbase+720, screenbase+760,screenbase+800
	.word	screenbase+840, screenbase+880,screenbase+920
	.word	screenbase+960
	
browserscreen
	.byte $23, $20, $20, $3A, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $6C, $E2, $7F
	.byte $20, $20, $20, $20, $20, $EC, $E2, $7B
	.byte $E1, $20, $20, $20, $20, $20, $20, $20
	.byte $77, $77, $77, $77, $77, $77, $77, $77
	.byte $77, $77, $77, $77, $77, $77, $77, $77
	.byte $77, $77, $77, $77, $74, $61, $20, $20
	.byte $20, $20, $20, $20, $20, $61, $20, $E1
	.byte $E1, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $65, $7F, $20, $20
	.byte $7C, $20, $20, $20, $20, $61, $20, $FF
	.byte $E1, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $E2, $7B
	.byte $6C, $6C, $62, $62, $7B, $EC, $E2, $20
	.byte $E1, $20, $20, $20, $20, $7B, $20, $6C
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $20, $E1
	.byte $E1, $20, $20, $6C, $7E, $61, $20, $20
	.byte $E1, $20, $FF, $7F, $61, $61, $20, $E1
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $20, $E1
	.byte $E1, $20, $6C, $7E, $20, $61, $20, $20
	.byte $E1, $E1, $20, $20, $61, $61, $20, $E1
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $65, $7B, $20, $FF
	.byte $E1, $6C, $7E, $20, $20, $61, $20, $20
	.byte $E1, $7C, $7B, $6C, $61, $7F, $20, $E1
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $7C, $E2, $20
	.byte $7C, $7C, $E2, $E2, $7E, $7E, $20, $20
	.byte $7C, $20, $7C, $7E, $7E, $20, $E2, $FB
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $62, $62, $62
	.byte $62, $62, $62, $62, $62, $62, $62, $62
	.byte $62, $62, $31, $2E, $30, $62, $62, $7E
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $46, $09, $0C
	.byte $05, $20, $02, $12, $0F, $17, $13, $05
	.byte $12, $20, $0B, $05, $19, $13, $3A, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $77, $77, $77
	.byte $77, $77, $77, $77, $77, $77, $77, $77
	.byte $77, $77, $77, $77, $77, $77, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $55, $10
	.byte $2F, $44, $0F, $17, $0E, $3A, $20, $0D
	.byte $0F, $16, $05, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $53, $08
	.byte $2B, $55, $10, $2F, $44, $0E, $3A, $20
	.byte $0D, $16, $20, $10, $01, $07, $05, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $4C, $06
	.byte $14, $2F, $52, $07, $14, $3A, $20, $03
	.byte $08, $07, $20, $04, $09, $12, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $52, $05
	.byte $14, $15, $12, $0E, $3A, $20, $03, $08
	.byte $04, $09, $12, $2F, $10, $0C, $01, $19
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $44, $3A
	.byte $20, $13, $05, $0C, $05, $03, $14, $20
	.byte $04, $12, $09, $16, $05, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $52, $3A
	.byte $20, $12, $05, $12, $05, $01, $04, $20
	.byte $04, $09, $12, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $50, $0C, $01
	.byte $19, $05, $12, $20, $0B, $05, $19, $13
	.byte $3A, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $77, $77, $77
	.byte $77, $77, $77, $77, $77, $77, $77, $77
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $45, $13
	.byte $03, $3A, $20, $05, $18, $09, $14, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $53, $10
	.byte $01, $03, $05, $3A, $20, $10, $01, $15
	.byte $13, $05, $2F, $10, $0C, $01, $19, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $20, $20, $20, $20
	.byte $20, $20, $20, $20, $74, $20, $4C, $06
	.byte $14, $2F, $52, $07, $14, $3A, $20, $10
	.byte $12, $05, $16, $2F, $0E, $05, $18, $14

wd_reading
	.byte	10, 10	; X/Y pos
	.byte	19, 3	; Width/Height
	.byte	$67	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$f0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $ee
	.byte	$dd, $d2, $85, $81, $84, $89, $8e, $87, $a0, $84, $89, $92, $85, $83, $94, $8f, $92, $99, $dd
	.text	$ed, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $fd
	
wd_status
	.byte	5, 10	; X/Y pos
	.byte	29, 3	; Width/Height
	.byte	$6e	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	
	.byte	$f0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $ee
	.byte	$dd, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $a0, $dd
	.text	$ed, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $fd

wd_driveselector
	.byte	0, 7	; X/Y pos
	.byte	40, 10	; Width/Height
	.byte	$67	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$F0, $F3, $D3, $85, $8C, $85, $83, $94
	.byte	$A0, $84, $92, $89, $96, $85, $EB, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $EE
	.byte	$DD, $A0, $B8, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $A0, $B9, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B0, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B1, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B2, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B3, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B4, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$DD, $B1, $B5, $BA, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $DD
	.byte	$ED, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $FD
	
wd_loading
	.byte	10, 11	; X/Y pos
	.byte	18, 3	; Width/Height
	.byte	$53	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$6C, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $7B
	.byte	$E1, $D2, $85, $81, $84, $89, $8e, $87
	.byte	$a0, $d3, $C9, $C4, $A0, $89, $8e, $86
	.byte	$8f, $61
	.byte	$7C, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $7E

wd_notapsid
	.byte	10, 11	; X/Y pos
	.byte	18, 3	; Width/Height
	.byte	$52	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$6C, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $7B
	.byte	$E1, $CE, $8F, $94, $A0, $81, $A0, $D0
	.byte	$D3, $C9, $C4, $A0, $86, $89, $8C, $85
	.byte	$A1, $61
	.byte	$7C, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $7E

wd_rsid
	.byte	7, 11	; X/Y pos
	.byte	24, 3	; Width/Height
	.byte	$52	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$6C, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $62, $62, $62, $62, $62, $62, $62
	.byte	$62, $62, $62, $62, $62, $62, $62, $7B
		; "Not a PSID file!"
		; "This is an RSID!"
		; "RSID is not supported!"
	.byte	$E1, $D2, $D3, $C9, $C4, $A0, $89, $93
	.byte	$A0, $8E, $8F, $94, $A0, $93, $95, $90
	.byte	$90, $8F, $92, $94, $85, $84, $A1, $61
	.byte	$7C, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $E2, $E2, $E2, $E2, $E2, $E2, $E2
	.byte	$E2, $E2, $E2, $E2, $E2, $E2, $E2, $7E

wd_sidinfo
	.byte	3, 5	; X/Y pos
	.byte	34, 14	; Width/Height
	.byte	$65	; color
	.byte	0	; number of choice elements
	.byte	0	; window type
	.byte	$F0, $F3, $CC, $8F, $81, $84, $89, $8E
	.byte	$87, $A0, $D0, $D3, $C9, $C4, $A0, $A0
	.byte	$EB, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $EE
	.byte	$DD, $AD, $BD, $CE, $81, $8D, $85, $BD
	.byte	$AD, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$DD, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$DD, $AD, $BD, $C1, $95, $94, $88, $8F
	.byte	$92, $BD, $AD, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$DD, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$DD, $AD, $BD, $D2, $85, $8C, $85, $81
	.byte	$93, $85, $84, $BD, $AD, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$DD, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$EB, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $F3
	.byte	$DD, $C3, $8C, $8F, $83, $8B, $BA, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$EB, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$F2, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $F3
	.byte	$DD, $D3, $C9, $C4, $BA, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$DD, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $A0, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$A0, $DD
	.byte	$EB, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$DB, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $F3
	.byte	$DD, $D3, $8F, $8E, $87, $BA, $A0, $A0
	.byte	$A0, $AF, $A0, $A0, $A0, $A0, $A0, $A0
	.byte	$DD, $D0, $8C, $81, $99, $94, $89, $8d
	.byte	$85, $BA, $A0, $A0, $A0, $A0, $BA, $A0
	.byte	$A0, $DD
	.byte	$ED, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$F1, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $C0, $C0, $C0, $C0, $C0, $C0, $C0
	.byte	$C0, $FD

; File operations work area
disklabel		.text	"0123456789abcdef0123456789abcdef"
		.byte	0
dirname		.text	"$"
cdcommand		.text	"cd"
filename		.text	"0123456789abcdef"
		.byte	0		; padding between filename and type
filetype		.text	"012"
numofentries	.word	0
firstdisplayed	.word	0
selectedentry	.word	0
temp1		.word	0
temp2		.word	0
	
; padding because Windows requires stack to be page aligned
	.align	$100

; Windows stack to save & restore data under window area
; - There are no overlapping windows used so 1 screen (color+character data) should be enough 
winbuflo	=	*
winbufhi	=	winbuflo+$0800 ; 1 

direntries = 	winbufhi	; entry length = 20 bytes (filename=16+$00+type=3)
