playsid	lda	#"0"
	sta	timer
	sta	timer+1
	sta	timer+3
	sta	timer+4
	ldx	startsong+1
	dex
	stx	currentsong
	jsr	setsongtimersource
	jsr	displayinfo
	jsr	loadsid
	bcc	+
	rts
+	lda	#"p"+$80
	sta	screenbase+$cd
	lda	#"l"+$40
	sta	screenbase+$ce
	lda	#"a"+$40
	sta	screenbase+$cf
	lda	#"y"+$40
	sta	screenbase+$d0
	lda	#$eb
	sta	screenbase+$d9
	lda	#$c0
	sta	screenbase+$da
	sta	screenbase+$db

	sei
	lda	$0314
	pha
	lda	$0315
	pha
	lda	#<irq
	ldx	#>irq
	sta	$0314
	stx	$0315
	ldx	#0
-	lda	$2,x
	sta	zp_save,x
	inx
	bne	-

playsong	sei
	lda	#"0"
	sta	timer
	sta	timer+1
	sta	timer+3
	sta	timer+4
; Init song
	jsr	setsongtimersource
	lda	songtimersource
	bne	+
	lda	currstd		; Init TED timer 1 with VBlank frequency
	asl
	ora	songstd
	asl
	tay
	lda	vblanktab,y
	ldx	vblanktab+1,y
	sta	ted_timer1lo
	stx	ted_timer1hi
	jmp	++
+	lda	currstd		; Init CIA timer with 60Hz
	asl
	asl
	tay
	lda	cia60hztab,y
	ldx	cia60hztab+1,y
	sta	c64cia1+4
	stx	c64cia1+5
+	jsr	displayinfo
	sta	ted_ramen
	ldx	#$18
	lda	#0
-	sta	c64sid,x
	sta	sid_solder,x
	dex
	bpl	-
	lda	currentsong
	ldx	#0
	ldy	#0
	jsr	doinitsong
; Init clock & timer
	ldx	currstd
	lda	timerjiffytab,x
	sta	timerjiffy
	lda	songtimersource
	beq	+
	lda	c64cia1+4
	ldx	c64cia1+5
	jsr	convtimer
	sta	ted_timer1lo
	stx	ted_timer1hi
+	lda	#%00001010
	sta	ted_irqmask
	sta	ted_romen
	cli

-	ldx	#%10111111	; Esc
	lda	#%00010000
	jsr	checkkey
	beq	exitplay

	ldx	#%01111111	; Space
	lda	#%00010000
	jsr	checkkey
	bne	+
	sei
	lda	ted_soundctrl
	pha
	lda	#0
	sta	ted_soundctrl
	sta	sid_solder+$18	
	jsr	wait4keyrelease
	ldx	#%01111111	; Space
	lda	#%00010000
-	jsr	checkkey
	bne	-
	jsr	wait4keyrelease
	lda	c64sid+$18
	sta	sid_solder+$18
	pla
	sta	ted_soundctrl
	cli
	jmp	--

+	ldx	#%10111111	; Right
	lda	#%00001000
	jsr	checkkey
	bne	++
	jsr	wait4keyrelease
	inc	currentsong
	lda	currentsong
	cmp	songs+1
	beq	+
	jmp	playsong
+	dec	currentsong
	bne	--

+	ldx	#%10111111	; Left
	lda	#%00000001
	jsr	checkkey
	bne	--
	jsr	wait4keyrelease
	dec	currentsong
	lda	currentsong
	cmp	#$ff
	bne	+
	inc	currentsong
	beq	--

+	jmp	playsong
	
exitplay	sei
	lda	#%00000010
	sta	ted_irqmask
	pla
	sta	$0315
	pla
	sta	$0314
	ldx	#0
	stx	ted_soundctrl
	stx	sid_solder+$18	
-	lda	zp_save,x
	sta	$2,x
	inx
	bne	-
	cli
+	rts

loadsid
-	jsr	chrin
	ldy	#0
	sta	(loadptr),y
	bit	st
	bvs	+
	lda	st
	bne	enderr
	inc	loadptr
	bne	-
	inc	ldanimphs
	lda	ldanimphs
	and	#3
	tay
	lda	loadanim,y
	sta	screenbase+$da
	inc	loadptr+1
	bne	-
+	lda	initaddress	; byte order swap for addresses
	ldx	initaddress+1
	sta	initaddress+1
	stx	initaddress
	lda	playaddress
	ldx	playaddress+1
	sta	playaddress+1
	stx	playaddress
	clc
	bcc	endnorm
enderr	sec
endnorm	php
	jsr	clrchans
	lda	#1
	jsr	close
	plp
	rts

irq	lda	ted_irqsource
	sta	ted_irqsource
	pha
	and	#%00001000
	beq	+
	sta	ted_ramen
	lda	$ff19
	pha
	eor	#$30
	sta	$ff19
	jsr	doplaysong
	pla
	sta	$ff19
	bit	io_soundtype	; No need to copy with NAE
	bmi	+
	ldx	#$18
-	lda	c64sid,x
	sta	sid_solder,x
	dex
	bpl	-
+	pla
	and	#%00000010
	beq	+
	lda	$ff19
	pha
	eor	#$50
	sta	$ff19
	jsr	inctimer
	pla
	sta	$ff19
+	sta	ted_romen
	pla
	tay
	pla
	tax
	pla
	rti
	
inctimer	dec	timerjiffy
	beq	+
	rts

+	ldx	currstd
	lda	timerjiffytab,x
	sta	timerjiffy

	ldx	timer+4
	inx
	cpx	#"9"+1
	bne	it1
	ldx	timer+3
	inx
	cpx	#"6"
	bne	it2
	ldx	timer+1
	inx
	cpx	#"9"+1
	bne	it3
	ldx	timer
	inx
	cpx	#"9"+1
	bne	it4
	ldx	#"0"
it4	stx	timer
	ldx	#"0"
it3	stx	timer+1
	ldx	#"0"
it2	stx	timer+3
	ldx	#"0"
it1	stx	timer+4
	jmp	displayinfo3

doinitsong
	jmp	(initaddress)
doplaysong
	jmp	(playaddress)

checkkey	stx	pio_keyboard
	stx	ted_keyblatch
	and	ted_keyblatch
	rts
	
wait4keyrelease
	lda	#0
-	sta	pio_keyboard
	sta	ted_keyblatch
	ldx	ted_keyblatch
	inx
	bne	-
	rts

convtimer	sta	dividend
	stx	dividend+1
	lda	#0
	sta	result
	sta	result+1
	sta	result+2
	lda	currstd
	asl
	ora	songstd
	tax
	lda	timerconvertertab,x
	sta	divisor
	ldx	#7
-	asl	result
	rol	result+1
	rol	result+2
	asl	divisor
	bcc	+
	clc
	lda	dividend
	adc	result
	sta	result
	lda	dividend+1
	adc	result+1
	sta	result+1
	bcc	+
	inc	result+2
+	dex
	bpl	-
	lda	result+1
	ldx	result+2
	rts

displayinfo
	ldx	#31
-	lda	name,x
	jsr	ascii2scr
	ora	#%10000000
	sta	screenbase+$11c,x
	lda	author,x
	jsr	ascii2scr
	ora	#%10000000
	sta	screenbase+$16c,x
	lda	released,x
	jsr	ascii2scr
	ora	#%10000000
	sta	screenbase+$1bc,x
	dex
	bpl	-
	
	lda	flags+1
	and	#%00110000
	lsr
	tax
	ldy	#0
-	lda	sidtab,x
	beq	+
	jsr	petscii2scr
	ora	#%10000000
	sta	screenbase+$261,y
	inx
	iny
	bne	-
+	lda	io_soundtype
	beq	+
	lsr
	lsr
	lsr
	clc
	adc	#16
+	tax
	ldy	#0
-	lda	cardtab,x
	beq	+
	jsr	petscii2scr
	ora	#%10000000
	sta	screenbase+$026c,y
	inx
	iny
	bne	-
+	bit	io_soundtype
	bpl	+
	lda	nae_control+15
	pha
	lsr
	lsr
	lsr
	lsr
	ora	#"0"+%10000000
	sta	screenbase+$0271
	pla
	and	#%00001111
	ora	#"0"+%10000000
	sta	screenbase+$0273
+	lda	io_soundtype
	and	#%00000011
	beq	+
	asl
	asl
	asl
	tax
-	lda	sidtypetab,x
	beq	+
	jsr	petscii2scr
	ora	#%10000000
	sta	screenbase+$026c,y
	inx
	iny
	bne	-
+	
displayinfo2
	lda	songtimersource
	asl
	asl
	asl
	tax
	ldy	#0
-	lda	speedtab,x
	beq	+
	jsr	petscii2scr
	ora	#%10000000
	sta	screenbase+$213,y
	inx
	iny
	bne	-

+	lda	flags+1
	and	#%00001100
	asl
	tax
-	lda	videostd,x
	beq	+
	jsr	petscii2scr
	ora	#%10000000
	sta	screenbase+$213,y
	inx
	iny
	bne	-
+
	ldx	currentsong
	inx
	txa
	jsr	byte2dec
	lda	numbuff+1
	ora	#%10000000
	sta	screenbase+$2b2
	lda	numbuff+2
	ora	#%10000000
	sta	screenbase+$2b3

	lda	songs+1
	jsr	byte2dec
	lda	numbuff+1
	ora	#%10000000
	sta	screenbase+$2b5
	lda	numbuff+2
	ora	#%10000000
	sta	screenbase+$2b6
	
displayinfo3
	ldx	#4
-	lda	timer,x
	ora	#%10000000
	sta	screenbase+$2c7,x
	dex
	bpl	-
	rts
	
ascii2scr	cmp	#0
	bne	+
	lda	#" "
	bne	++
+	cmp	#"a"+$20
	bcc	+
	cmp	#"z"+$21
	bcs	+
	eor	#%01100000
+	rts
	
petscii2scr
	cmp	#0
	bne	+
	lda	#" "
	bne	++
+	cmp	#"@"
	bcc	+
	cmp	#"z"
	bcs	+
	eor	#%01000000
+	cmp	#"A"
	bcc	+
	cmp	#"Z"
	bcs	+
	eor	#%10000000
+	rts

byte2dec	ldx	#" "
	stx	numbuff
	stx	numbuff+1
	stx	numbuff+2
	ldx	#0
-	cmp	dectab,x
	bcc	++
	ldy	numbuff,x
	cpy	#" "
	bne	+
	pha
	lda	#"0"
	sta	numbuff,x
	pla
+	inc	numbuff,x
	sec
	sbc	dectab,x
	jmp	-
+	inx
	cpx	#2
	bne	-
	ora	#"0"
	sta	numbuff,x
	rts

setsongtimersource
	lda	#0
	sta	songtimersource
	lda	currentsong
	and	#%00000111
	tay
	lda	currentsong
	lsr
	lsr
	lsr
	eor	#%00000011
	tax
	lda	#0
-	sec
	rol
	dey
	bpl	-
	and	speed,x
	beq	+
	inc	songtimersource
+	rts
	
loadanim	.byte	$ec, $fb, $fe, $fc
ldanimphs	.byte	0

; SID file header data
sidheader
magicID		.text	"PSID"
version		.word	0
dataoffset	.word	0
loadaddress	.word	0
initaddress	.word	0
playaddress	.word	0
songs		.word	0
startsong		.word	0
speed		.word	0, 0
name		.text	"0123456789abcdef0123456789abcdef"
author		.text	"0123456789abcdef0123456789abcdef"
released		.text	"0123456789abcdef0123456789abcdef"
flags		.word	0
startPage		.byte	0
pageLength	.byte	0
secondSIDAddress	.byte	0
thirdSIDAddress	.byte	0
sidheaderend

; Timer frequency converter work area
dividend		.byte	0, 0
divisor		.byte	0
result		.byte	0, 0, 0

; Player work area
; ----------------
currstd		.byte	0	; Machine standard (PAL = 0, NTSC = 1)

currentsong	.byte	0	; Selected song number
songstd		.byte	0	; Standard defined for SID file (unkown, PAL = 0, NTSC = 1, PAL+NTSC=currstd)
songtimersource	.byte	0	; 0: VBlank, 1: Timer
timerjiffy	.byte	0	; Timer counter for increasing value
timer		.text	"00:00"	; Current timer values

; Temporary data
xtemp		.byte	0
ytemp		.byte	0

; Playback helper tables
; ----------------------
; Timer increase frequency (adjusted to current screen refresh)
timerjiffytab	.byte	50, 60 ; PAL, NTSC

; ============================
; plus/4
;  PAL  timer clock = 886724
;  NTSC timer clock = 894886
; C64
;  PAL  timer clock = 985248
;  NTSC timer clock = 1022727
; ============================
; VBlank to timer value converter table ( key = current std * 2 + song std ) 
vblanktab	.word	17734, 14779	; PAL VBlank@PAL, NTSC VBLank@PAL
	.word	17898, 14915	; PAL VBlank@NTSC, NTSC VBlank@NTSC
	
; CIA 60Hz table (key = current std)
cia60hztab
	.word	16421, 17045

; Timer converter (divider) tab ( key = current std * 2 + song std )
timerconvertertab
; PAL TED timer freq = PAL CIA timer freq * 0,9 => CIA timer freq * 230/256
; eight binary fraction digits (number/256)
	.byte	230, 222		; PAL@PAL=0.9; NTSC@PAL=0.867
	.byte	233, 224		; PAL@NTSC=0,91; NTSC@NTSC=0,875
speedtab	.null	"VBlank@"
	.null	"Timer@"	
videostd	.null	"unknown"
	.null	"PAL    "
	.null	"NTSC   "
	.null	"PAL+NTSC"
sidtab	.null	"Unknown"
	.null	"6581   "
	.null	"8580   "
	.null	"6581/8580"
	
sidtypetab
	.null	"TED"
	.text	"    "
	.null	"6581"
	.text	"   "
	.null	"8580"

; io_soundtype
; bit 0-1: 
; - 00: TED
; - 01: 6581
; - 02: 8580
; bit 7
; - 0: TED/SIDCard
; - 1: NAE
		;0123456789abcdef
cardtab	.text	"TED"
	.byte	0
	.text	    "            "
	.text	"SIDCard/"
	.byte	0
	.text	         "       "
	.text	"NAE v0.0/"
	.byte	0

zp_save	.fill	256, 0

; Hexadecimal-to-Decimal conversion data 
dectab	.byte	100, 10
numbuff	.text	"   "
